%{

extern int yylex();
extern int yylineno;

#define YYERROR_VERBOSE

int yyerror(const char *s)
{
  fprintf(stderr, "In line %d: %s", yylineno, s);
  abort();
}

%}

%defines
%verbose
%glr-parser
%expect 1
%debug

%union {
  int i;
}

%token
  KW_IMPORTS "IMPORTS"
  KW_FROM "FROM"
  KW_NOTUSED "NOTUSED"
  TOK_UpperIdentifier "uppperid"
  TOK_LowerIdentifier "lowerid"

%%

Imports:
  KW_IMPORTS SymbolsFromModuleList ';'
;

SymbolsFromModuleList:
  SymbolsFromModule
| SymbolsFromModuleList SymbolsFromModule
;

SymbolsFromModule:
  SymbolList KW_FROM TOK_UpperIdentifier AssignedIdentifier
;

AssignedIdentifier:
  TOK_LowerIdentifier
| /* empty */
;

SymbolList:
  Symbol
| SymbolList ',' Symbol
;

Symbol:
  TOK_UpperIdentifier
| TOK_LowerIdentifier
;
